/**
 * Author: Ravi Tamada
 * URL: www.androidhive.info
 * twitter: http://twitter.com/ravitamada
 * */
package com.uoc.fivedevices.librerias;

import java.util.ArrayList;
import java.util.List;

import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONObject;

import android.content.Context;

public class UserFunctions {
	
	private JSONParser jsonParser;
	
	
	//*********************SERVIDOR LOCAL************************************
	
	private static String loginURL = "http://192.168.1.70/app_server/";
	private static String registerURL = "http://192.168.1.70/app_server/";
	private static String addURL = "http://192.168.1.70/app_server/";
	private static String mydisposURL = "http://192.168.1.70/app_server/";
	private static String disposURL = "http://192.168.1.70/app_server/";
	private static String relationsURL = "http://192.168.1.70/app_server/";
	private static String searchUserURL = "http://192.168.1.70/app_server/";
	private static String mycontactsURL = "http://192.168.1.70/app_server/";
	private static String devicesDetailsURL = "http://192.168.1.70/app_server/";
	
	
	private static String valoraURL = "http://192.168.1.70/app_server/";
	private static String fichaURL = "http://192.168.1.70/app_server/";
	private static String eliminaURL = "http://192.168.1.70/app_server/";
	
	private static String searchDeviceURL = "http://192.168.1.70/app_server/";
	
	
	
	/*********************SERVIDOR INTERNET************************************
	private static String loginURL = "http://apparatos.no-ip.org/app_server/";
	private static String registerURL = "http://apparatos.no-ip.org/app_server/";
	private static String addURL = "http://apparatos.no-ip.org/app_server/";
	private static String mydisposURL = "http://apparatos.no-ip.org/app_server/";
	private static String disposURL = "http://apparatos.no-ip.org/app_server/";
	private static String relationsURL = "http://apparatos.no-ip.org/app_server/";
	private static String searchUserURL = "http://apparatos.no-ip.org/app_server/";
	private static String mycontactsURL = "http://apparatos.no-ip.org/app_server/";
	private static String devicesDetailsURL = "http://apparatos.no-ip.org/app_server/";
	
	
	private static String valoraURL = "http://apparatos.no-ip.org/app_server/";
	private static String fichaURL = "http://apparatos.no-ip.org/app_server/";
	private static String eliminaURL = "http://apparatos.no-ip.org/app_server/";
	
	private static String searchDeviceURL = "http://apparatos.no-ip.org/app_server/";
	*/
	
	private static String login_tag = "login";
	private static String register_tag = "register";
	private static String add_tag = "add";
	private static String relations_tag = "addcontact";
	private static String mydispos_tag = "mydispos";
	private static String mycontacts_tag = "mycontacts";
	
	private static String searchDeviceByEan_tag = "searchDeviceEan";
	private static String searchDeviceDetails_tag = "searchDeviceDetails";
	
	private static String cameraDetails_tag = "cameraDetails";
	private static String audioDetails_tag = "audioDetails";
	private static String phoneDetails_tag = "phoneDetails";
	private static String computerDetails_tag = "computerDetails";
	private static String televisionDetails_tag = "televisionDetails";
	
	private static String addevent_tag = "addEvent";
	private static String event_tag = "events";
	
	//Opciones sobre dispositivos asociados al usuario
	private static String valora_tag = "valoraDevice";
	private static String ficha_tag = "fichaDevice";
	private static String elimina_tag = "eliminaDevice";
	//private static String opina_tag = "opinaDevice";
	
	private static String dispos_tag = "dispos";
	private static String searchUser_tag = "searchUser";
	
	
	
	// constructor
	public UserFunctions(){
		jsonParser = new JSONParser();
	}
	
	/**
	 * function make Login Request
	 * @param email
	 * @param password
	 * */
	public JSONObject loginUser(String email, String password){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", login_tag));
		params.add(new BasicNameValuePair("email", email));
		params.add(new BasicNameValuePair("password", password));
		JSONObject json = jsonParser.getJSONFromUrl(loginURL, params);
		// return json
		// Log.e("JSON", json.toString());
		return json;
	}
	
	/**
	 * function make Login Request
	 * @param name
	 * @param email
	 * @param password
	 * */
	public JSONObject registerUser(String name, String email, String password){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", register_tag));
		params.add(new BasicNameValuePair("name", name));
		params.add(new BasicNameValuePair("email", email));
		params.add(new BasicNameValuePair("password", password));
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(registerURL, params);
		// return json
		return json;
	}
/**PRUEBA AGREGAR EVENTOS**************************************************/	
	
	/**
	 * function make AddDevice Request
	 * @param user_id
	 * @param event_description
	 * */
	
	public JSONObject addEvent (String type, String user_id, String event_description){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", addevent_tag));
		params.add(new BasicNameValuePair("user_id", user_id));
		params.add(new BasicNameValuePair("event", event_description));
		
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(valoraURL, params);
		// return json
		return json;
	}

/**PRUEBA CONSULTAR EVENTOS********************************************/	
	
	/**
	 * function make AddDevice Request
	 * @param user_id
	 * @param device_id
	 * */
	
	public JSONObject Events (){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", event_tag ));
	
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(disposURL, params);
		// return json
		return json;
	}
	
/**PRUEBA AGREGAR DEVICES**************************************************/	
	
	/**
	 * function make AddDevice Request
	 * @param user_id
	 * @param device_id
	 * */
	
	public JSONObject addDevice (String user_id, String device_id){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", add_tag));
		params.add(new BasicNameValuePair("user_id", user_id));
		params.add(new BasicNameValuePair("device_id", device_id));
		
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(valoraURL, params);
		// return json
		return json;
	}
	
/*********** VALORAR DEVICE**********************************************/

	/**
	 * function make valora device
	 * @param user_id
	 * @param device_id
	 * @param valoration
	 * */
	
	public JSONObject valoraDevice (String _id, String user_id, String valoration){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", valora_tag));
		params.add(new BasicNameValuePair("_id", _id));
		params.add(new BasicNameValuePair("user_id", user_id));
		params.add(new BasicNameValuePair("valoration", valoration));
		
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(valoraURL, params);
		// return json
		return json;
	}
	
/**PRUEBA MUESTRA FICHA MYDEVICES**********************************************/

	/**
	 * function make AddDevice Request
	 * @param user_id
	 * @param device_id
	 * */
	
	public JSONObject fichaDevice (String _id){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", ficha_tag));
		params.add(new BasicNameValuePair("_id", _id));
		
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(fichaURL, params);
		// return json
		return json;
	}
/**PRUEBA ELIMINA MYDEVICE**********************************************/

	/**
	 * function make AddDevice Request
	 * @param relation_id
	 * @param 
	 * */
	
	public JSONObject eliminaMyDevice (String user_id, String relation_id){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", elimina_tag));
		params.add(new BasicNameValuePair("user_id", user_id));
		params.add(new BasicNameValuePair("relation_id", relation_id));

		
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(eliminaURL, params);
		// return json
		return json;
	}	
/**PRUEBA AGREGAR RELACION ENTRE USUARIOS******************************/	
	
	/**
	 * function make AddDevice Request
	 * @param user_id
	 * @param device_id
	 * */
	
	public JSONObject addRelation (String user1_id, String user2_id){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", relations_tag));
		params.add(new BasicNameValuePair("user1_id", user1_id));
		params.add(new BasicNameValuePair("user2_id", user2_id));
		
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(relationsURL, params);
		// return json
		return json;
	}
	
/**PRUEBA CONSULTAR DEVICES********************************************/	
	
	/**
	 * function make AddDevice Request
	 * @param user_id
	 * @param device_id
	 * */
	
	public JSONObject Devices (){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", dispos_tag ));
	
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(disposURL, params);
		// return json
		return json;
	}

/**PRUEBA CONSULTAR DETALLES DE DEVICE********************************************/	
	
	/**
	 * function make AddDevice Request
	 * @param user_id
	 * @param device_id
	 * */
	
	public JSONObject DeviceDetails (String ean){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", searchDeviceDetails_tag ));
		params.add(new BasicNameValuePair("ean", ean ));
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(devicesDetailsURL, params);
		// return json
		return json;
	}
	
/**BUSQUEDA DE USUARIO POR EMAIL********************************************/
/**PRUEBA CONSULTAR DETALLES DE CAMARAS********************************************/	
	
	/**
	 * function make AddDevice Request
	 * @param user_id
	 * @param device_id
	 * */
	
	public JSONObject CameraDetails (String ean){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", cameraDetails_tag ));
		params.add(new BasicNameValuePair("ean", ean ));
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(devicesDetailsURL, params);
		// return json
		return json;
	}
/**PRUEBA CONSULTAR DETALLES DE AUDIO********************************************/	
	
	/**
	 * function make AddDevice Request
	 * @param user_id
	 * @param device_id
	 * */
	
	public JSONObject AudioDetails (String ean){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", audioDetails_tag ));
		params.add(new BasicNameValuePair("ean", ean ));
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(devicesDetailsURL, params);
		// return json
		return json;
	}	

/**PRUEBA CONSULTAR DETALLES DE PHONE********************************************/	
	
	/**
	 * function make AddDevice Request
	 * @param user_id
	 * @param device_id
	 * */
	
	public JSONObject PhoneDetails (String ean){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", phoneDetails_tag ));
		params.add(new BasicNameValuePair("ean", ean ));
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(devicesDetailsURL, params);
		// return json
		return json;
	}
	
/**PRUEBA CONSULTAR DETALLES DE PC********************************************/	
	
	/**
	 * function make AddDevice Request
	 * @param user_id
	 * @param device_id
	 * */
	
	public JSONObject ComputerDetails (String ean){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", computerDetails_tag ));
		params.add(new BasicNameValuePair("ean", ean ));
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(devicesDetailsURL, params);
		// return json
		return json;
	}

/**PRUEBA CONSULTAR DETALLES DE PC********************************************/	
	
	/**
	 * function make AddDevice Request
	 * @param user_id
	 * @param device_id
	 * */
	
	public JSONObject TelevisionDetails (String ean){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", televisionDetails_tag ));
		params.add(new BasicNameValuePair("ean", ean ));
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(devicesDetailsURL, params);
		// return json
		return json;
	}
	
/**BUSQUEDA DE USUARIO POR EMAIL********************************************/	
	
	/**
	 * La función solicita la buscaqueda de usuario por email
	 * @param email
	 * 
	 * */
	
	public JSONObject SearchUser(String email){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", searchUser_tag ));
		params.add(new BasicNameValuePair("email", email ));
	
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(searchUserURL, params);
		// return json
		return json;
	}
	
	
/**BUSQUEDA DE DEVICE POR EAN CAPTURADO********************************************/	
	
	/**
	 * La función solicita la buscaqueda de usuario por email
	 * @param email
	 * 
	 * */
	
	public JSONObject SearchDeviceByEan(String ean){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", searchDeviceByEan_tag ));
		params.add(new BasicNameValuePair("ean", ean ));
	
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(searchDeviceURL, params);
		// return json
		return json;
	}
	
	
/**PRUEBA CONSULTAR USERDEVICES********************************************/	
	
	/**
	 * function make AddDevice Request
	 * @param user_id
	 * @param device_id
	 * */
	
	public JSONObject MyDevices (String user_id){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", mydispos_tag ));
		params.add(new BasicNameValuePair("user_id", user_id));

		
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(mydisposURL, params);
		// return json
		return json;
	}
	
/**PRUEBA AGREGAR DEVICES**************************************************/
/**PRUEBA CONSULTAR LOS CONTACTOS DE CADA USUARIO**************************/	
	
	/**
	 * function make AddDevice Request
	 * @param user_id
	 * @param device_id
	 * */
	
	public JSONObject MyContacts (String user_id){
		// Building Parameters
		List<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("tag", mycontacts_tag ));
		params.add(new BasicNameValuePair("user_id", user_id));

		
		
		// getting JSON Object
		JSONObject json = jsonParser.getJSONFromUrl(mydisposURL, params);
		// return json
		return json;
	}
	
/**PRUEBA AGREGAR DEVICES**************************************************/
	
	/**
	 * Function get Login status
	 * */
	public boolean isUserLoggedIn(Context context){
		BBDDUserSession db = new BBDDUserSession(context);
		int count = db.getRowCount();
		if(count > 0){
			// user logged in
			return true;
		}
		return false;
	}
	
	/**
	 * Function to logout user
	 * Reset Database
	 * */
	public boolean logoutUser(Context context){
		BBDDUserSession db = new BBDDUserSession(context);
		db.resetTables();
		return true;
	}
	
}
