<?php

/**
 * Fichero encargado de procesar las peticiones procedentes de la aplicación (en formato JSON)
 * y realizar la respuesta correspondiente mediante cadena JSON
**/ 

  /**
 * Comprueba la petición POST mediante la etiqueta tag 
 */
if (isset($_POST['tag']) && $_POST['tag'] != '') {
    // Toma el tiepo de petición (tag)
    $tag = $_POST['tag'];

    // Incluye controlador de la base de datos
    require_once 'include/DB_Functions.php';
    $db = new DB_Functions();

    // TIPOS DE RESPUESTAS
    $response = array("tag" => $tag, "success" => 0, "error" => 0);
    $response2 = array("tag" => $tag, "success" => 0, "error" => 0, "userdevices" => 0);
    $response3 = array("tag" => $tag, "success" => 0, "error" => 0, "user_id" => 0);



/****************REALIZA REGISTRO MEDIANTE MAIL I PASSWORD*******************************************************/

    // Revisa el tipo de petición tag->type

    if ($tag == 'login') {
        // Request type is check Login

        $email = $_POST['email'];
        $password = $_POST['password'];

        // check for user

        $user = $db->getUserByEmailAndPassword($email, $password);
        if ($user != false) {
            // user found
            // echo json with success = 1
            $response["success"] = 1;
            $response["uid"] = $user["unique_id"];
            $response["user"]["name"] = $user["name"];
            $response["user"]["email"] = $user["email"];
            $response["user"]["created_at"] = $user["created_at"];
            $response["user"]["updated_at"] = $user["updated_at"];
            echo json_encode($response);
        } else {
            // usuario no encontrado, responde con mensaje de error
            // json con error = 1
            $response["error"] = 1;
            $response["error_msg"] = "Email o contraseña incorrectos!";
            echo json_encode($response);
        }


 /********************REALIZA REGISTRO DE NUEVO USUARIO**********************************************************/  

    } else if ($tag == 'register') {
        // Petición de registro de nuevo usuario
        $name = $_POST['name'];
        $email = $_POST['email'];
        $password = $_POST['password'];

        // comprueba si el usuario existe
        if ($db->isUserExisted($email)) {
            // en caso de existir contesta con error
            $response["error"] = 2;
            $response["error_msg"] = "El usuario ya existe";
            echo json_encode($response);
        } else {
            // almacena nuevo ususario
            $user = $db->storeUser($name, $email, $password);
            if ($user) {
                // usuario almacenado con exito
                $response["success"] = 1;
                $response["uid"] = $user["unique_id"];
                $response["user"]["name"] = $user["name"];
                $response["user"]["email"] = $user["email"];
                $response["user"]["created_at"] = $user["created_at"];
                $response["user"]["updated_at"] = $user["updated_at"];
                echo json_encode($response);
            } else {
                // falló el almacenamiento del usuario
                $response["error"] = 1;
                $response["error_msg"] = "Ocurrio un erro en el registro del usuario";
                echo json_encode($response);
            }
        }

/*****************AÑADE A USERSRELATIONS LOS VINCULOS ENTRE USUARIO*************************************************/

}else if ($tag == 'addcontact') {
// Petición de registro ADD en tabla users-devices

        $user1_id = $_POST['user1_id'];
        $user2_id = $_POST['user2_id'];

//PENDIENTE METODO PARA COMPROBAR SI EXISTA YA LA RELACION ENTRE USUARIOS

        $relation = $db->storeUserRelation($user1_id, $user2_id);	
	
	if ($relation) {
                // relación entre usuarios almacenada con éxito
                $response["success"] = 1;
		$response["user1_id"] = $relation["user1_id"];
		$response["user2_id"] = $relation["user2_id"];

		/***NEW EVENT***************************************************/

		$notification1 = "ha*agregado*a*";
		$notification2 = "*como*contacto.";
		$user = "";
		$contact_name="";

		$user_session = $db-> getUserById($user1_id);

		if ($user_session) {
			$user = $user_session["name"];
		}

		$contact = $db-> getUserById($user2_id);

		if ($contact) {
			$contact_name = $contact["name"];
			
		}
		$event = $notification1.$contact_name.$notification2;
		$db-> newEvent($user, $event);
		/**************************************************************/

		echo json_encode($response);
} else {
$response["error"] = 1;
$response["error_msg"] = "Ha ocurrido un error al guardar el registro en usersrelation";
$response["respuesta storeUserRelation"] = $device;
$response["user1_id"] = $user1_id;
$response["user2_id"] = $user2_id;
echo json_encode($response);

}


/******************AÑADE RELACION USUARIO-DISPOSITIVO******************************************************************/

}else if ($tag == 'add') {


	$json = "";
	$i = 0; 	

        $user_id = $_POST['user_id'];
        $device_id = $_POST['device_id'];

//PENDIENTE METODO PARA COMPROBAR SI EXISTA YA LA RELACION USUARIO-DISPOSITIVO

        $device = $db->storeUserDevice($user_id, $device_id);	
	
	if ($device) {
                // guarda la relacion con exito y volveremos a pedir los devices del ususario para actualizar en local

		/***NEW EVENT***************************************************/
		$notification1 = "ha*agregado*";
		$notification2 = "*a*su*lista*de*dispositivos.";
		$user = "";
		$modelo="";

		$user_session = $db-> getUserById($user_id);

		if ($user_session) {
			$user = $user_session["name"];
		}

		$device = $db-> getDeviceByEan($device_id);

		if ($device) {
			$modelo = $device["modelo"];
			
		}
		$event = $notification1.$modelo.$notification2;
		$db-> newEvent($user, $event);
		/**************************************************************/
		
		$userDevices = $db->getDevicesByUser($user_id);
	
			$json .= " { \"userdevices\" : [ ";

			 while($row = mysql_fetch_array($userDevices)){
			    	if($i > 0)
			     	$json .= ",";
				   
			    	
				$json .= " { 
				\"id\" : ".$row['_id'].", 
				\"user_id\" : ".$row['user_id'].", 
				\"device_id\" : ".$row['device_id'].", 
				\"valoration\": ".$row['valoration'].", 
				\"marca\" : ".$row['marca'].", 
				\"modelo\" : ".$row['modelo']." ";    

				$json .= "} ";   
			    	$i++;
			   	}  
  
				$json .= " ] ";
			   	$json .= " } ";  
			   	
				
				echo ($json);


} else {
$response["error"] = 1;
$response["error_msg"] = "Ha ocurrido un error al guardar el registro en user-devices";
$response["respuesta storeUserDevice"] = $device;
$response["user_id"] = $user_id;
$response["device_id"] = $device_id;
echo json_encode($response);

}



/*****************ETIQUETA QUE IDENTIFICA SOLICITUD DE VALORAR DISPOSITIVO**********************************************/

}else if ($tag == 'valoraDevice') {

	$relation_id = $_POST['_id'];        
	$user_id = $_POST['user_id'];
	$valoration = $_POST['valoration'];	


        $result_valora = $db->valoraDevice($relation_id, $user_id, $valoration);	
	
	if ($result_valora) {
                // valoracion actualizada con éxito
                $response["success"] = 1;
		$response["msg"] = "Se actualizo la valoracion correctamente";
		echo json_encode($response);

		/***NEW EVENT***************************************************/
		$notification1 = "ha*valorado*";
		$notification2 = "*como*";
		$user = "";
		$device_id="";
		$modelo="";
		$valoration="";

		$user_session = $db-> getUserById($user_id);

		if ($user_session) {
			$user = $user_session["name"];
		}

		$relation = $db-> getRelationById($relation_id);

		if ($relation) {
			$valoration = $relation["valoration"];
			$device_id = $relation["device_id"];
		}

		$device = $db-> getDeviceByEan($device_id);

		if ($device) {
			$modelo = $device["modelo"];
			
		}
		$event = $notification1.$modelo.$notification2.$valoration;
		$db-> newEvent($user, $event);
		/**************************************************************/


} else {
$response["error"] = 1;
$response["error_msg"] = "Ha ocurrido un error al actualizar la valoración del dispositivo";
echo json_encode($response);

}


/*****************ETIQUETA QUE ELIMINA DISPOSITIVO DE LISTA PERSONAL****************************************************/

}else if ($tag == 'eliminaDevice') {
// Petición de eliminacion de dispositivo en tabla users-devices

	$json = "";
	$i = 0; 	

        $user_id = $_POST['user_id'];
	$relation_id = $_POST['relation_id'];


        $result_elimina = $db->deleteDeviceRelation($user_id, $relation_id);	
	
	if ($result_elimina) {
                
                $response["success"] = 1;
		$response["msg"] = "El registro se ha eliminado correctamente";
			
		$userDevices = $db->getDevicesByUser($user_id);


			$json .= " { \"userdevices\" : [ ";

			 while($row = mysql_fetch_array($userDevices)){
			    	if($i > 0)
			     	$json .= ",";
				   
			    	
				$json .= " { 
				\"id\" : ".$row['_id'].", 
				\"user_id\" : ".$row['user_id'].", 
				\"device_id\" : ".$row['device_id'].", 
				\"valoration\": ".$row['valoration'].", 
				\"marca\" : ".$row['marca'].", 
				\"modelo\" : ".$row['modelo']." ";    

				$json .= "} ";   
			    	$i++;
			   	}  
  
				$json .= " ] ";
			   	$json .= " } ";  
			   	
				
				echo ($json);
		
				
} else {
$response["error"] = 1;
$response["error_msg"] = "Ha ocurrido un error al eliminar el registro";
echo json_encode($response);

}



/*****************ETIQUETA QUE SOLICITA TODOS LOS DISPOSITIVOS**************************************************/

}else if ($tag == 'dispos') {

	$json = "";
	$i = 0; 	

        $result = $db->getDevices();	
	
	if ($result) {
//GENERA JSON
		
			$json .= " { \"devices\" : [ ";

			 while($row = mysql_fetch_array($result)){
			    	if($i > 0)
			     	$json .= ",";
				
			    	$json .= " { 
				\"id\" : ".$row['_id'].", 
				\"type\" : ".$row['type'].",
				\"device_id\" : ".$row['device_id'].", 
				\"marca\" : ".$row['marca'].", 
				\"modelo\" : ".$row['modelo']." ";   
				$json .= "} ";   
			    	$i++;
			   	}  
  
				$json .= " ] ";
			   	$json .= " } ";  
			   	
				
				echo ($json);

} else {
$response["error"] = 1;
$response["error_msg"] = "Ha ocurrido un error recuperar los dispositivos del servidor";
echo json_encode($response);

}
/*****************ETIQUETA QUE SOLICITA EVENTOS**********************************************************************/

}else if ($tag == 'events') {

	$json = "";
	$i = 0; 	

        $result = $db->getEvents();	
	
	if ($result) {
		
			$json .= " { \"events\" : [ ";

			 while($row = mysql_fetch_array($result)){
			    	if($i > 0)
			     	$json .= ",";
				
			    	$json .= " { \"id\" : ".$row['_id'].", \"user_id\" : ".$row['user_id'].", \"event\" : ".$row['event']." ";   
				$json .= "} ";   
			    	$i++;
			   	}  
  
				$json .= " ] ";
			   	$json .= " } ";  
			
				echo ($json);

} else {
$response["error"] = 1;
$response["error_msg"] = "Ha ocurrido un error recuperar los dispositivos del los eventos";
echo json_encode($response);

}


/*****************SOLICITA LOS DISPOSTIVOS DE UNA USUARIO CONCRETO*****************************************************/

}else if ($tag == 'mydispos') {

        $user_id = $_POST['user_id'];

	$json = "";
	$i = 0; 	

        $result = $db->getDevicesByUser($user_id);	
	
	if ($result) {

		
			$json .= " { \"userdevices\" : [ ";

			 while($row = mysql_fetch_array($result)){
			    	if($i > 0)
			     	$json .= ",";
				   
			    	
				$json .= " { 
				\"id\" : ".$row['_id'].", 
				\"user_id\" : ".$row['user_id'].", 
				\"device_id\" : ".$row['device_id'].", 
				\"valoration\": ".$row['valoration'].", 
				\"marca\" : ".$row['marca'].", 
				\"modelo\" : ".$row['modelo']." ";    

				$json .= "} ";   
			    	$i++;
			   	}  
  
				$json .= " ] ";
			   	$json .= " } ";  
			   	
				
				echo ($json);

} else {
$response["error"] = 1;
$response["error_msg"] = "Ha ocurrido un error recuperar el registro user-devices";
$response["user_id"] = $user_id;
echo json_encode($response);

}



/*****************SOLICITA LOS DISPOSITIVOS DE LOS CONTACTOS DEL USUARIO*********************************************/

}else if ($tag == 'contactdispos') {

        $user_id = $_POST['user_id'];

	$json = "";
	$i = 0; 	

        $result = $db->getDevicesByUser($user_id);	
	
	if ($result) {

		
			$json .= " { \"userdevices\" : [ ";

			 while($row = mysql_fetch_array($result)){
			    	if($i > 0)
			     	$json .= ",";
				   
			    	
				$json .= " { 	\"id\" : ".$row['_id'].", 
						\"user_id\" : ".$row['user_id'].", 
						\"device_id\" : ".$row['device_id'].", 
						\"valoration\": ".$row['valoration'].", 
						\"marca\" : ".$row['marca'].", 
						\"modelo\" : ".$row['modelo']." ";    

				$json .= "} ";   
			    	$i++;
			   	}  
  
				$json .= " ] ";
			   	$json .= " } ";  
			   	
				
				echo ($json);

} else {
$response["error"] = 1;
$response["error_msg"] = "Ha ocurrido un error recuperar el registro de dispositivos del usuario";
$response["user_id"] = $user_id;
echo json_encode($response);

}


/*****************BUSCA UN USUARIO POR SU DIRECCION DE CORREO********************************************************/
}else if ($tag == 'searchUser') {
 // Request type is Register new user
        $email = $_POST['email'];
	$json = "";
	$i = 0; 

            $result = $db->getUserByEmail($email);

            if ($result) {

                $response["success"] = 1;
		$response["uid"] = $result["uid"];
		$response["unique_id"] = $result["unique_id"];
		$response["name"] = $result["name"];
		$response["email"] = $result["email"];
		echo json_encode($response);

            } else {
                // user failed to store
                $response["error"] = 1;
                $response["error_msg"] = "Error, no se encuentra al usuario";
                echo json_encode($response);
            }


/******************BUSCA UN USUARIO POR SU IDENTIFICADOR UNICO*********************************************************/
}else if ($tag == 'searchUserById') {
 // Request type is Register new user
        $user_id = $_POST['user_id'];
	$json = "";
	$i = 0; 

            $result = $db->getUserByEmail($user_id);

            if ($result) {

                $response["success"] = 1;
		$response["unique_id"] = $result["unique_id"];
		$response["name"] = $result["name"];
		$response["email"] = $result["email"];
		echo json_encode($response);

            } else {
                // user not found
                $response["error"] = 1;
                $response["error_msg"] = "Error, no se encuentra al usuario";
                echo json_encode($response);
            }



/******************BUSCA UN DISPOSITIVO POR SU CODIGO EAN*******************************************************************/
}else if ($tag == 'searchDeviceEan') {
 // Request type is Register new user
        $ean = $_POST['ean'];
	$json = "";
	$i = 0; 

            $result = $db->getDeviceByEan($ean);

            if ($result) {

                $response["success"] = 1;
		$response["_id"] = $result["_id"];
		$response["ean"] = $result["device_id"];
		$response["marca"] = $result["marca"];
		$response["modelo"] = $result["modelo"];
		echo json_encode($response);

            } else {
                // user failed to store
                $response["error"] = 1;
                $response["error_msg"] = "Error, no se encuentra dispositivo";
                echo json_encode($response);
            }




/******************BUSCA LOS DETALLES DE UN DETERMINADO DISPOSITIVO ( POR EAN)***********************************************/
}else if ($tag == 'searchDeviceDetails') {
 // Request type is Register new user
        $ean = $_POST['ean'];
	$json = "";
	$i = 0; 

            $result = $db->getDeviceDetailsByEan($ean);
    
            if ($result) {

                $response["success"] = 1;
		$response["_id"] = $result["_id"];
		$response["ean"] = $result["device_id"];
		$response["imagen"] = $result["imagen"];
		$response["marca"] = $result["marca"];
		$response["modelo"] = $result["modelo"];
		$response["resolucion"] = $result["resolucion"];
		$response["sensor"] = $result["sensor"];
		$response["pantalla"] = $result["pantalla"];
		$response["zoom"] = $result["zoom"];
		$response["review"] = $result["review"];
		
		echo json_encode($response);

            } else {
                // user failed to store
                $response["error"] = 1;
                $response["error_msg"] = "Error, no se encuentra la dicha del dispositivo";
                echo json_encode($response);
            }


/******************BUSCA LOS DETALLES DE UN DISPOSITIVOS TIPO CAMARA ( POR EAN)*********************************************/
}else if ($tag == 'cameraDetails') {
 // Request type is Register new user
        $ean = $_POST['ean'];
	$json = "";
	$i = 0; 

            $result = $db->getCameraDetailsByEan($ean);
    
            if ($result) {

                $response["success"] = 1;
		$response["_id"] = $result["_id"];
		$response["ean"] = $result["device_id"];
		$response["imagen"] = $result["imagen"];
		$response["marca"] = $result["marca"];
		$response["modelo"] = $result["modelo"];
		$response["resolucion"] = $result["resolucion"];
		$response["sensor"] = $result["sensor"];
		$response["pantalla"] = $result["pantalla"];
		$response["zoom"] = $result["zoom"];
		$response["web"] = $result["web"];
		$response["review"] = $result["review"];
		echo json_encode($response);

            } else {
                // user failed to store
                $response["error"] = 1;
                $response["error_msg"] = "Error, no se encuentra la dicha del dispositivo";
                echo json_encode($response);
            }

/*****************BUSCA LOS DETALLES DE UN DISPOSITIVOS TIPO TELEFONO ( POR EAN)*******************************************/
}else if ($tag == 'phoneDetails') {
 // Request type is Register new user
        $ean = $_POST['ean'];
	$json = "";
	$i = 0; 

            $result = $db->getPhoneDetailsByEan($ean);
    
            if ($result) {

                $response["success"] = 1;
		$response["_id"] = $result["_id"];
		$response["ean"] = $result["device_id"];
		$response["imagen"] = $result["imagen"];
		$response["marca"] = $result["marca"];
		$response["modelo"] = $result["modelo"];

		$response["procesador"] = $result["procesador"];
		$response["so"] = $result["so"];
		$response["pantalla"] = $result["pantalla"];
		$response["resolucion"] = $result["resolucion"];
		$response["camara"] = $result["camara"];
		
		
		$response["web"] = $result["web"];
		$response["review"] = $result["review"];
		echo json_encode($response);

            } else {
                // user failed to store
                $response["error"] = 1;
                $response["error_msg"] = "Error, no se encuentra la dicha del dispositivo";
                echo json_encode($response);
            }



/******************RECUPERA LOS CONTACTOS DE UN DETERMINADO USUARIO*********************************************************/

}else if ($tag == 'mycontacts') {
 // Request type is Register new user
        $user_id = $_POST['user_id'];

	$json = "";
	$i = 0; 

            $result = $db->getContactsByUser($user_id);
            if ($result) {

			$json .= " { \"usersrelation\" : [ ";

			 while($row = mysql_fetch_array($result)){
			    	if($i > 0)
			     	$json .= ",";			  
				$json .= " { \"id\" : ".$row['_id'].", 
				\"user1_id\" : ".$row['user1_id'].", 
				\"user2_id\" : ".$row['user2_id'].",  
				\"name\": ".$row['name'].", 
				\"email\" : ".$row['email']." ";  
				
				$json .= "} ";   
			    	$i++;
			   	}  
  
				$json .= " ] ";
			   	$json .= " } ";  
			   	
				
				echo ($json);



            } else {
                // user failed to store
                $response["error"] = 1;
                $response["error_msg"] = "Ha ocurrido un error en la recuperación de los contactos del usuario";
                echo json_encode($response);
            }


/*************EN CASO DE NO ENCONTRAR LA ETIQUETA CORRESPONDIENTE DEVUELVE AVISO****************************************/
    } else {
        echo "Peticion no valida";
    }
} else {
    echo "Acceso Denegado";
}
?>
