package com.uoc.fivedevices;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONArray;
import org.json.JSONObject;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;

import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnKeyListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;
import android.os.Bundle;

@SuppressWarnings("unused")
public class FivedevicesActivity extends Activity {
	/**
    // Actividad llamada cuando se crea por primera vez
	
	EditText user;
	EditText pass;
	Button validar;
	//Variables necesarias para intruducir datos de usuario (nombre y contraseña)
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.login);
        
        //La actividad tiene como interface el recurso layout llamado login
        
        user = (EditText) findViewById(R.id.username);
        pass = (EditText) findViewById(R.id.password);
        validar = (Button) findViewById(R.id.login);     
        //Relación de las variables con los elementos de la interfaz
        
    validar.setOnClickListener(new OnClickListener() {
    //@SuppressWarnings("rawtypes")
	@Override
    public void onClick(View v) {   
		Intent intent_menu = new Intent(FivedevicesActivity.this, AndroidTabLayoutActivity.class);
		Intent intent = new Intent(FivedevicesActivity.this, FrmMensaje.class);
		//Crea el intent para luego saltar de activity en caso de identificacion OK
		
		
		ArrayList<String> parametros = new ArrayList<String>();
       
    	parametros.add("Usuario");
    	parametros.add(user.getText().toString());
    	parametros.add("Contrasena");
    	parametros.add(pass.getText().toString());
    	
    	
    	
    	// Array para pasar los datos intruducidos por el usuario
    	// A continuación realizamos la llamada a Servidor Web PHP local 192.168.1.70 mediante la clase Post definida abajo
    	
    	try {
    	                        Post post = new Post();
    	                        JSONArray datos = post.getServerData(parametros,"http://192.168.1.70/android/login.php");
    	// No se puede poner localhost, carga la consola de Windows
    	// y escribe ipconfig/all para ver tu IP
    	if (datos != null && datos.length() > 0) {
    	                        JSONObject json_data = datos.getJSONObject(0);
    	                        int numRegistrados = json_data.getInt("ID_USUARIO");
    	if (numRegistrados > 0) {
    							
    	                        Toast.makeText(getBaseContext(),"Usuario correcto", Toast.LENGTH_SHORT).show();
    	                        //Informa que el ususario es correcto y...
    	                        //Añadimos la información al intent
    	                        //Bundle b = new Bundle();
    	                        //b.putString("NOMBRE", user.getText().toString());
    	    	            	//intent.putExtras(b);
    	                        startActivity(intent_menu);                                             
    	                        //Arranca el intent con el correspondiente layout
    							}
    	} else {
    							
    	                        Toast.makeText(getBaseContext(),
    	                                                                       "Usuario incorrecto. ", Toast.LENGTH_SHORT)
    	                                                                                              .show();
    	                        startActivity(intent_menu);//inicia igualmente, para agilizar para pruebas
    	                        }
    	} catch (Exception e) {
    	                        Toast.makeText(getBaseContext(),
    	                                                                       "Error al conectar con el servidor. ",
    	                                                                       Toast.LENGTH_SHORT).show();
    	}
    	// FIN Llamada a Servidor Web PHP
    	
    	                                               }
    	                        });
    	}

    	class Post {
    		// La clase Post se encarga de realizar la comunicación http
    		// Conecta con el servidor definido al formar el Array JSON, en el try de la captura del click en login
    		// Recibe  respuesta del servidor, que identifica o no al usuario (contrastando con su base de datos)
    		
    	                        private InputStream is = null;
    	                        private String respuesta = "";

    	private void conectaPost(ArrayList<String> parametros, String URL) {
    	                        ArrayList<BasicNameValuePair> nameValuePairs;
    	                        try {

    	                                               HttpClient httpclient = new DefaultHttpClient();

    	                                               HttpPost httppost = new HttpPost(URL);
    	                                               nameValuePairs = new ArrayList<BasicNameValuePair>();

    	                                               if (parametros != null) {
    	                                                                       for (int i = 0; i < parametros.size() - 1; i += 2) {
    	nameValuePairs.add(new BasicNameValuePair((String)parametros.get(i), (String)parametros.get(i + 1)));
    	                                                                       }
    	httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));
    	                                               }
    	                                               HttpResponse response = httpclient.execute(httppost);
    	                                               HttpEntity entity = response.getEntity();
    	                                               is = entity.getContent();
    	                        } catch (Exception e) {

    	                                               Log.e("log_tag", "Error in http connection " + e.toString());

    	                        } finally {

    	                        }
    	}

    	private void getRespuestaPost() {
    	
    	try {
    	BufferedReader reader = new BufferedReader(
    	new InputStreamReader(is, "iso-8859-1"), 8);
    	StringBuilder sb = new StringBuilder();
    	String line = null;
    	while ((line = reader.readLine()) != null) {
    	                        sb.append(line + "\n");
    	}
    	is.close();
    	respuesta = sb.toString();
    	Log.e("log_tag", "Cadena JSon " + respuesta);
    	} catch (Exception e) {

    	                        Log.e("log_tag", "Error converting result " + e.toString());

    	                        }
    	}

    	@SuppressWarnings("finally")
    	private JSONArray getJsonArray() {
    	                        JSONArray jArray = null;
    	                        try {

    	                                               jArray = new JSONArray(respuesta);

    	                        } catch (Exception e) {

    	                        } finally {
    	                                               return jArray;
    	                        }
    	}

    	public JSONArray getServerData(ArrayList<String> parametros, String URL) {
    	                        conectaPost(parametros, URL);
    	                        if (is != null) {
    	                                               getRespuestaPost();
    	                        }
    	                        if (respuesta != null && respuesta.trim() != "") {
    	                                                                                              return getJsonArray();
    	                                                                       } else {
    	                                                                                              return null;
    	                                                                       }
    	                                               }
    	                        }**/
    	}
        
        
        

        
        
        
    
