package com.uoc.fivedevices;

import java.util.Collections;

import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import com.uoc.fivedevices.librerias.BBDDContactos;
import com.uoc.fivedevices.librerias.BBDDUserSession;
import com.uoc.fivedevices.librerias.UserFunctions;

public class ValoraDeviceActivity extends Activity {
	
	Button btnValora;
	Button btnBack;
	
	EditText valoraBox;
	TextView txtInstrucciones;
	TextView marca;
	TextView modelo;
	
	String relation_id;
	String valoration;
	String device_id;
	String deviceModelo;
	String deviceMarca;
	
	private static String KEY_SUCCESS = "success";
	private static String KEY_MARCA = "marca";
	private static String KEY_MODELO = "modelo";
	
	@Override
	protected void onCreate(Bundle bundle) {
		super.onCreate(bundle);
		setContentView(R.layout.valora_layout);
	
		Bundle extras = getIntent().getExtras();
		if(extras !=null)
		{
			device_id = extras.getString("device_id");
			relation_id = extras.getString("relation_id");
			
		}
        
        valoraBox = (EditText)findViewById(R.id.valoraBox);
        txtInstrucciones = (TextView)findViewById(R.id.instrucciones);
        marca = (TextView)findViewById(R.id.marca);
        modelo = (TextView)findViewById(R.id.modelo);
        
        btnValora = (Button)findViewById(R.id.btnValora);
        btnBack = (Button)findViewById(R.id.btnBack);
        
        
        
        BBDDUserSession db2 = new BBDDUserSession(this);	//Abrimmos base de datos
        final String user_session = db2.getUserUid();					//para recuperar identidad de la session
        
        UserFunctions userFunction = new UserFunctions();
        JSONObject json = userFunction.SearchDeviceByEan(device_id); 
        
        try {
			if (json.getString(KEY_SUCCESS) != null) {
				
				String res = json.getString(KEY_SUCCESS); 
				if(Integer.parseInt(res) == 1){
					
					marca.setText(json.getString(KEY_MARCA));
					String deviceModelo = json.getString(KEY_MODELO); 
					deviceModelo = deviceModelo.replace("*", " ");
					modelo.setText(deviceModelo);
					
					//txtInstrucciones.setText("Clica sobre este mensaje para añadir a tus contactos");
					
					
			        
	
			    	
				}
			}
        }catch (JSONException e) {
			e.printStackTrace();}
        
 
        
        btnBack.setOnClickListener(new View.OnClickListener(){
        	public void onClick(View view) {
        		
				finish();
        	}
        });
	
	

        
        btnValora.setOnClickListener(new View.OnClickListener() {

        
			public void onClick(View view) {
				valoration="*";
				valoration = valoraBox.getText().toString();
				valoration = valoration.replace(" ","*");
				
				UserFunctions userFunction = new UserFunctions();
		        JSONObject json = userFunction.valoraDevice(relation_id, user_session, valoration);
		        
		        try {
					if (json.getString(KEY_SUCCESS) != null) {
						
						String res = json.getString(KEY_SUCCESS); 
						if(Integer.parseInt(res) == 1){
							
							marca.setText(json.getString(KEY_MARCA));
							modelo.setText(json.getString(KEY_MODELO));
							
							//txtInstrucciones.setText("Clica sobre este mensaje para añadir a tus contactos");
							
							
					        
			
					    	
						}
					}
		        }catch (JSONException e) {
					e.printStackTrace();}
			}});
			
	}}
        /**
        txtInstrucciones.setOnClickListener(new View.OnClickListener() {

        
			public void onClick(View view) {
        
					UserFunctions userFunction2 = new UserFunctions();
					JSONObject json_relation = userFunction2.addRelation(user_session, userIdFound);
					
					try {
						if (json_relation.getString(KEY_SUCCESS) != null) {
							
							
							txtInstrucciones.setText("Usuario añadido correctamente a tus contactos");	
							int uid = Integer.parseInt(userUidFound);
							dbcontactos.insertarRelacion(uid, user_session, userIdFound);
							
							
						}}catch (JSONException e) {
							e.printStackTrace();}
			}});
			**/
	

					
							

