package com.uoc.fivedevices.adaptadores;

import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import com.uoc.fivedevices.librerias.BBDDMyContacts;

public class AdaptadorBDMyContacts {


public static final String KEY_ROWID = "_id";
public static final String KEY_USER1 = "user1_id";
public static final String KEY_USER2 = "user2_id";
public static final String KEY_CNAME = "name";
public static final String KEY_CEMAIL = "email";
private static final String DATABASE_TABLE = "mycontacts";
private Context context;
private SQLiteDatabase database;
private BBDDMyContacts dbHelper;

public AdaptadorBDMyContacts(Context context) {
	this.context = context;
}

public AdaptadorBDMyContacts open() throws SQLException {
	dbHelper = new BBDDMyContacts(context);
	database = dbHelper.getWritableDatabase();
	return this;
}

public void close() {
	dbHelper.close();
}

//RETORNA UN CURSOR CON TODOS LOS ITEMS
	public Cursor fetchAllTodos() {
		return database.query(DATABASE_TABLE, new String[] { KEY_ROWID,
				KEY_USER1, KEY_USER2, KEY_CNAME, KEY_CEMAIL}, null, null, null,
				null, null);
	}
	
//DEVUELVE UN CURSOR CON LA INFO DEL REGISTRO
	public Cursor fetchTodo(long rowId) throws SQLException {
		Cursor mCursor = database.query(true, DATABASE_TABLE, new String[] {
				KEY_ROWID, KEY_USER1, KEY_USER2, KEY_CNAME, KEY_CEMAIL},
				KEY_ROWID + "=" + rowId, null, null, null, null, null);
		if (mCursor != null) {
			mCursor.moveToFirst();
		}
		return mCursor;
	}
	
}


