package com.uoc.fivedevices.librerias;

/*
Esta clase se encarga de leer el servicio ayudado por el método JSONManager 
y guardar en base de datos de usuarios
*/

import org.json.JSONArray;
import org.json.JSONException;
import android.app.Activity;
public class JSONParserContactos {

	private Activity activity;

	public JSONParserContactos(Activity a){
	   activity = a;
	}


	public void parseJSONContactos(JSONArray ContactosArray) throws JSONException{
		BBDDMyContacts dbContactos =  new BBDDMyContacts(activity);
		
		dbContactos.resetTables();
		
	  for(int i = 0; i < ContactosArray.length(); i++){
		  
	     Relation l = new Relation();
	     l.setIdRelation(ContactosArray.getJSONObject(i).getInt("id"));
	     l.setUser1ID(ContactosArray.getJSONObject(i).getString("user1_id"));
	     l.setUser2ID(ContactosArray.getJSONObject(i).getString("user2_id"));
	     l.setContactName(ContactosArray.getJSONObject(i).getString("name"));
	     l.setContactEmail(ContactosArray.getJSONObject(i).getString("email"));

	     dbContactos.addContactoPoolUpdate(l);
	  }
	  dbContactos.commitPoolUpdate();
	  dbContactos.close();
	}
	
}
